# std::basic_ios<CharT,Traits>::exceptions

From cppreference.com
< cpp‎ | io‎ | basic ios

std::ios_base::iostate exceptions() const; | (1) |
void exceptions( std::ios_base::iostate except ); | (2) |

Gets and sets the exception mask of the stream. The exception mask determines the error states on occurrence of which the stream throws exception of type failure.

1) Returns the exception mask.
2) Sets the exception mask to `except`.

### Parameters

except | - | exception mask

### Return value

1) The current exception mask.
2) (none)

### Notes

| This section is incomplete Reason: discuss LWG2349 and link from ios_base::clear, and from (un)formatted(i/o)utputfunction requirement pages (or perhaps the behavior should be fully elaborated on the requirement pages and linked from here). See also stackoverflow.com/a/35089910

### Example

Run this code

    #include <iostream>
    #include <fstream>

    int main()
    {
        int ivalue;
        try {
            std::ifstream in("in.txt");
            in.exceptions(std::ifstream::failbit);
            in >> ivalue;
        } catch (std::ios_base::failure& fail) {
            // handle exception here
        }
    }

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/io/basic_ios/exceptions&oldid=103764"